#include "swMathConst.h"
#include <cmath>
#include <limits>


#if defined(PI)  //  for djgpp
#	undef PI
#endif


//-----------------------------------------------------------------------------------------
//  struct swMathConst

//const double swMathConst::INF = std::numeric_limits<double>::max();  //  1.79769e+308
const double swMathConst::INF = std::numeric_limits<double>::infinity();  //  1.#INF
const double swMathConst::NaN = std::numeric_limits<double>::quiet_NaN();  //  -1.#IND
//const double swMathConst::NaN = std::numeric_limits<double>::signaling_NaN();  //  -1.#INF

const double swMathConst::PI = atan(1.0) * 4.0;
const double swMathConst::_2_PI = swMathConst::PI * 2.0;
const double swMathConst::_4_PI = swMathConst::PI * 4.0;
const double swMathConst::PI_2 = swMathConst::PI / 2.0;
const double swMathConst::PI_3 = swMathConst::PI / 3.0;
const double swMathConst::PI_4 = swMathConst::PI / 4.0;
const double swMathConst::PI_6 = swMathConst::PI / 6.0;

const double swMathConst::E = exp(1.0);

const double swMathConst::TO_RAD = swMathConst::PI / 180.0;
const double swMathConst::TO_DEG = 180.0 / swMathConst::PI;

double swMathConst::EPS = 1.0e-5;
//double swMathConst::EPS = std::numeric_limits<double>::epsilon();  //  2.22045e-016

int swMathConst::IterationLimit = 1000;
