#include "BarSimulator.h"
#include <cstdlib>
#include "glut.h"


//--------------------------------------------------------------------------------------------------
//

CBarSimulator simulator(30.0, -2.0);


//--------------------------------------------------------------------------------------------------
//

void render(void)
{
	glClear(GL_COLOR_BUFFER_BIT);
	
	glPushMatrix();
	   simulator.simulate();
	glPopMatrix();
	   
	glutSwapBuffers();
}

void initialize(void) 
{
	glClearColor(1.0, 1.0, 1.0, 1.0);
	glShadeModel(GL_FLAT);
}

void reshape(int w, int h)
{
	glViewport(0, 0, (GLsizei)w, (GLsizei)h);
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	double aspectRatio = double(w) / double(h);
	if (aspectRatio > 1.0)
		gluOrtho2D(-5.0 * aspectRatio, 45.0 * aspectRatio, -5.0, 55.0);
	else 
		gluOrtho2D(-5.0, 45.0, -5.0 / aspectRatio, 55.0 / aspectRatio);
	
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
	glutInitWindowSize(500, 600); 
	glutInitWindowPosition(100, 100);
	glutCreateWindow("Inclined Bar");
	
	initialize();
	
	glutDisplayFunc(render); 
	glutReshapeFunc(reshape); 
	glutIdleFunc(render);
	glutMainLoop();
	
	return 0;
}
