#if !defined(__CHAPTER15_PROJECTILE_H_)
#define __CHAPTER15_PROJECTILE_H_ 1


//---------------------------------------------------------------------------------------------
//  class CProjectile  :  ߷¸  ߻ü

class CProjectile
{
private:
	CProjectile(const CProjectile&);
	CProjectile& operator=(const CProjectile&);

public:
	CProjectile(double x0, double y0, double yf, double v0, double deg);
	virtual ~CProjectile()   {}

public:
	//  鿡    ð( ҿð)
	virtual double getElapsedTime() const;

	//  ð t  ӵ
	virtual double getVx(double t) const;
	virtual double getVy(double t) const;

	//  ð t  ġ
	virtual double getX(double t) const;
	virtual double getY(double t) const;

protected:
	//  ʱ ġ(߻)
	double x0_, y0_;
	//   ġ(ǥ)
	double yf_;
	//  ʱ ӵ
	double vx0_, vy0_;

	//  ߷ ӵ
	double g_;
};


//---------------------------------------------------------------------------------------------
//  class CProjectileWithDragForce  :  ׷(drag force)  ߻ü

class CProjectileWithDragForce : public CProjectile
{
private:
	CProjectileWithDragForce(const CProjectileWithDragForce&);
	CProjectileWithDragForce& operator=(const CProjectileWithDragForce&);

public:
	CProjectileWithDragForce(double x0, double y0, double yf, double vi, double deg, double m, double c);
	virtual ~CProjectileWithDragForce()  {}

public:
	//  鿡    ð
	/*virtual */double getElapsedTime() const;

	//  ð t  ӵ
	/*virtual */double getVx(double t) const;
	/*virtual */double getVy(double t) const;

	//  ð t  ġ
	/*virtual */double getX(double t) const;
	/*virtual */double getY(double t) const;

private:
	double solveElapsedTime(double init) const;
	double calcElapsedTime(double init) const;

protected:
	//  
	double m_;
	//  ׷ 
	double c_;
};


#endif  //  __CHAPTER15_PROJECTILE_H_
